{smcl}
{* *! 30mar2012}{...}

{title:Title}

{p2colset 5 21 23 2}{...}
{p2col :{hi:ksmirnov2} {hline 2}}Kolmogorov-Smirnov equality-of-distributions test allowing for weights{p_end}
{p2colreset}{...}


{marker syntax}{...}
{title:Syntax}

{phang}
One-sample Kolmogorov-Smirnov test

{p 8 17 2}
{cmd:ksmirnov2} {varname} {ifin} {weight} {cmd:,} {opth "onesample(exp:exp)"}


{phang}
Two-sample Kolmogorov-Smirnov test

{p 8 17 2}
{cmd:ksmirnov2} {varname} {ifin} {weight} {cmd:,} {opth "by(varlist:groupvar)"}
 [{opt e:xact}]

{marker description}{...}
{title:Description}

{pstd}
{cmd:ksmirnov2} is a slight extension of Stata's ksmirnov command that allows for sampling weights. Most of the code is taken from the original ksmirnov command, I only changed a few lines,so 
see {help ksmirnov} for more details.{break}{break}
{hi:fweight}s and {hi:aweight}s are allowed and can be specified in the usual way, see {help weight}. The only other difference to the original command is that the syntax is slightly different 
for one-sample tests: {help exp} must be specified as {opth "onesamp(exp:exp)"} instead of after {it: varname} and should not include the "=" sign, see {help ksmirnov2##examples:Examples} below.

{marker examples}{...}
{title:Examples}

{pstd}Setup{p_end}
{phang2}{cmd:. webuse ksxmpl}{p_end}
{phang2}{cmd:. summarize x}{p_end}
{pstd}A rather naive form of weights...{p_end}
{phang2}{cmd:. gen wgt=1}{p_end}

{pstd}One-sample test{p_end}
{phang2}{cmd:. ksmirnov2 x [fw=wgt], onesamp(normal((x-r(mean))/r(sd)))}{p_end}

{pstd}Two-sample test{p_end}
{phang2}{cmd:. ksmirnov2 x [fw=wgt], by(group)}

{pstd}Two-sample test, exact value{p_end}
{phang2}{cmd:. ksmirnov2 x [fw=wgt], by(group) exact}

{title:Remarks}
{pstd}If you find any mistakes or have any suggestions for improvements, please send me an email to {browse "mailto:mittag@uchicago.edu":mittag@uchicago.edu}. As I said above, most of this code is from the original 
ksmirnov.ado file, I only added a few lines, so I'm not sure about the rights to use and distribute. I certainly don't object to any non-commercial use of the parts I wrote, anything else is between you and Stata...
